Subject: Re: git-http-backend: anonymous read, authenticated write

From: Jakub Narębski <[email-masked]>
Date: Thu, 11 Apr 2013 18:43:53 +0200

W dniu 11.04.2013 03:56, Jeff King napisał:

> So _if_ you fixed it by setting http.receivepack (which I think is the
> simplest thing under Apache, since matching the query string there is
> hard), then you would need a version of git with that fix on the
> client side to actually have git prompt for the password correctly.
> 
> But your fix under lighttpd is much better, as it asks for the
> credentials up front (which means the client does not go to any work
> creating a packfile just to find out that it does not have access).

According to http://paperlined.org/apps/git/SmartHTTP_Ubuntu.html
it is (supposedly) not that hard in Apache (though it requires mod_rewrite):

  RewriteCond %{QUERY_STRING} =service=git-receive-pack [OR]
  RewriteCond %{REQUEST_URI} /git-receive-pack$
  RewriteRule (.*) $1 [E=AUTHREQUIRED:yes]

  <Location /git/>
      Order Deny,Allow
      Deny from env=AUTHREQUIRED

      AuthType Basic
      AuthName "Git Access"
      Require group committers

      Satisfy Any
  <Location>

Not tested.

P.S. By the way, is there some debugger for apache config (mod_rewrite
and deny/allow)?
-- 
Jakub Narębski